%define anolis_release 2

%global desc %{expand: \
Pyflakes is similar to PyChecker in scope, but differs in that it does\
not execute the modules to check them. This is both safer and faster,\
although it does not perform as many checks. Unlike PyLint, Pyflakes\
checks only for logical errors in programs; it does not perform any\
check on style.}

Name:           pyflakes
# WARNING: When updating pyflakes, check not to break flake8!
Version:        2.5.0
Release:        %{anolis_release}%{?dist}
Summary:        A simple program which checks Python source files for errors

License:        MIT
URL:            https://github.com/PyCQA/pyflakes
Source0:        %{pypi_source}
Source1:        http://cdn.debian.net/debian/pool/main/p/pyflakes/pyflakes_2.4.0-2.debian.tar.xz

Patch0:         %{name}-1.1.0-python3-man.patch

#https://github.com/PyCQA/pyflakes/commit/836631f2f73d45baa4021453d89fc9fd6f52be58
Patch1:         1000-fix-error-reporter-and-testsuite-in-3.11.4.patch

BuildArch:      noarch

BuildRequires:  python%{python3_pkgversion}-devel
BuildRequires:  python%{python3_pkgversion}-pytest

%py_provides python3-%{name}

%description %{desc}

%package -n python%{python3_pkgversion}-%{name}
Summary:        %{summary}

%description -n python%{python3_pkgversion}-%{name}
%{desc}

%package -n python%{python3_pkgversion}-%{name}-doc
Summary:        %{name} documentation

%description -n python%{python3_pkgversion}-%{name}-doc
Documentation for %{name}.

%prep
%autosetup -p1 -a 1

%generate_buildrequires
%pyproject_buildrequires

%build
%pyproject_wheel

%install
%pyproject_install
%pyproject_save_files %{name}

mv %{buildroot}%{_bindir}/pyflakes %{buildroot}%{_bindir}/pyflakes-%{python3_version}
ln -s pyflakes-%{python3_version} %{buildroot}%{_bindir}/pyflakes-3
ln -s pyflakes-3 %{buildroot}%{_bindir}/pyflakes

install -Dpm 644 debian/pyflakes3.1 %{buildroot}%{_mandir}/man1/pyflakes-%{python3_version}.1
ln -s pyflakes-%{python3_version}.1 %{buildroot}%{_mandir}/man1/pyflakes-3.1
ln -s pyflakes-3.1 %{buildroot}%{_mandir}/man1/pyflakes.1

%check
%pytest -v

%files -n python%{python3_pkgversion}-%{name} -f %{pyproject_files}
%{_bindir}/pyflakes-%{python3_version}
%{_bindir}/pyflakes-3
%{_bindir}/pyflakes
%{_mandir}/man1/pyflakes-%{python3_version}.1*
%{_mandir}/man1/%{name}-3.1*
%{_mandir}/man1/pyflakes.1*
%exclude %{python3_sitelib}/pyflakes/test

%files -n python%{python3_pkgversion}-%{name}-doc
%doc AUTHORS NEWS.rst README.rst

%changelog
* Wed Mar 20 2024 Bo Ren <rb01097748@alibaba-inc.com> - 2.5.0-2
- Rebuild with python3.11
- fix error reporter and testsuite in 3.11.4+

* Fri Apr 21 2023 Funda Wang <fundawang@yeah.net> - 2.5.0-1
- Import package for anolis 23
